################################################################################
#
#  the analyzer: interface to alloy
#
################################################################################


class Analyzer
  def generate(val, results, theSkolem)
    pp val

    # get the "official" alloy type of the result
    typeNum = theSkolem["types"][0]["type"][0]["ID"]

    sigs = results["sig"]

    # find the estimated type by looking for the name of the value in the set of atoms in each type
    type_with_this = sigs.keys.select { |x| x != "univ" && sigs[x]["atom"] != nil && sigs[x]["atom"].keys.member?(val)}
    type = type_with_this[0].sub("this/", "")

    #type = sigs.keys.select { |x| x != "univ" && sigs[x]["ID"] == typeNum }[0]

    pp type.scan(/\w+/)[-1]
    type = type.scan(/\w+/)[-1]
    if type == "Int"
      val.to_i
    elsif type == "Sequence"
      tuples = results["field"]["elem"]["tuple"]
      tuple_names = tuples.map{|t| t["atom"].keys[0].scan(/\w+/)[0]}
      values = tuple_names.map{|t| @value_cache[t.intern]}
      Sequence.new(values.uniq)
    else
      eval(type + ".new")
    end
  end

  def analyze(quantifiedVar, alloyCode, valueCache)

    @value_cache = valueCache.invert
    pp @value_cache

    puts "WORKING ON INSTANCE **************************************************"

    File.open("/tmp/compile.als", 'w') {|f| f.write(alloyCode) }

    File.delete('/tmp/compile.als.xml') if File::exists?('/tmp/compile.als.xml')

    alloy_path = File.expand_path(File.dirname(__FILE__) + "/calloy.jar")
    cmd = 'java -jar ' + alloy_path + ' /tmp/compile.als > /dev/null 2> /dev/null'
#    puts cmd

    system(cmd)
    result = File.open("/tmp/compile.als.xml", 'r') { |f| f.read }
    if result == "" 
      false
    else
      true
#       instance = XmlSimple.xml_in('/tmp/compile.als.xml', { 'KeyAttr' => 'label' })
# #      pp instance
#       results = instance["instance"][0]
#       skolems = results["skolem"]
#       if skolems == nil
#         true
#       else
#         theSkolem = skolems["$" + quantifiedVar.to_s]
#         pp theSkolem
        
#         # get the name of the atom that is the result
#         val = theSkolem["tuple"][0]["atom"].keys[0]
#         generate(val, results, theSkolem)
#       end
    end
  end
end
